package at.jku.students;

import at.jku.ssw.Iterator;

public class ArrayQueueIterator extends Iterator {

  private char[] queue;
  private int head, count;
  
  ArrayQueueIterator(char[] queue, int head, int count) {
    this.queue = queue;
    this.head = head;
    this.count = count;
  }
  
  public boolean hasNext() {
    return count > 0;
  }
  
  public char next() {
    char value = queue[head];
    head = (head + 1) % queue.length;
    count--;
    return value;
  }
}